//***********************************//
//             Processing            //
//           Rolex emulator          //
//***********************************//
//        Christian Couderc          //
//         www.voilec.com            //
//***********************************//
// 211126


int clockMode = 0; // Change to check :  0 = Hour from PC // 1 = full speed


PShape  RolexHour, rolexHourExt, rolexHourFill, rolexHourDisk, rolexHourY, rolexHourDelta;
PShape  RolexMinute,  rolexMinNeedle, rolexMinDiskRear, rolexMinFill, rolexMinCenterShadow;
PShape  RolexSecond, rolexSecNeedle, rolexSecRearDisk, rolexSecMainDisk, rolexSecCenterAxis, rolexSecCenterShadow;
PImage Rolex;

int colorShadow= #B0B0FF ;
int colorSteel= #5D626F ;
int colorFluo = #C2F0AC;//#9BE302 ;


float  angleH, angleM, angleS= 96*60 ;
long topTime ;
char buffer = 60;
//////////////////////////////////////////////
void setup() 
{
size(1228, 940);
Rolex = loadImage("Rolex_1228x940.jpg");
createNeedles() ;
}
///////////////////////////////////////////

void draw() 
{
background(204);
image (Rolex, 0,0);
//redCross() ; ; // Only for debug : comment
infos();
translate (width/2,height/2);
//createNeedles() ; // Optional : Only to sweep grey level : else comment

fulSpeed (clockMode); // = true for real clock, = 1 for fullspeed

rotate(radians(angleH));
shape (RolexHour);
rotate(radians(-angleH+angleM));
shape (RolexMinute);
rotate(radians(-angleM+angleS));
shape (RolexSecond);
}

//////////////////////////////////////////
int hourR1 = -160;//-135 ; // point
int hourR2 = -130 ;//-100 ; // Base of external triangle
int hourR3 = -10 ; // Base of internal triangle
//int hourR4 = -10 ; //  base

int hourLarge = 15; //11 ;
int hourLargeF = 9;//5 ;
int hourR5 = 75;//70 ; // Base of external fill
int hourR6 = 20 ; // Base of internal fill
int hourR7 = -105;//-80 ; //  Center big disk
int hourDiamDisk = 50;//45;
int k1X = -2;      int k1Y = hourR7+25 ;
int k2X = -2;      int k2Y = hourR7+2 ;
int k3X = -23;      int k3Y = hourR7-10 ;
int k4X = -20;      int k4Y = hourR7-14 ;
int k5X = 0;      int k5Y = hourR7-3 ;
int k6X = 20;      int k6Y = hourR7-14 ;
int k7X = 20;      int k7Y = hourR7-10 ;
int k8X = 2;      int k8Y = hourR7+2 ;
int k9X = 2;      int k9Y = hourR7+25 ;

void createHour ()
{
noFill();  
stroke(colorSteel);

RolexHour = createShape (GROUP);
rolexHourExt = createShape(); 
rolexHourExt.beginShape();
rolexHourExt.noStroke();
rolexHourExt.vertex(0, hourR1);
rolexHourExt.vertex(-hourLarge, hourR2);
rolexHourExt.vertex(-hourLarge, hourR3);
rolexHourExt.vertex(hourLarge, hourR3);
rolexHourExt.vertex(hourLarge, hourR2);
rolexHourExt.fill(color (colorSteel));
rolexHourExt.endShape();

fill(colorFluo);
rolexHourFill = createShape(); 
rolexHourFill.beginShape();
rolexHourFill.strokeWeight (1);
rolexHourFill.vertex(-hourLargeF, -hourR5);
rolexHourFill.vertex(-hourLargeF, -hourR6);
rolexHourFill.vertex(hourLargeF, -hourR6);
rolexHourFill.vertex(hourLargeF, -hourR5);
rolexHourFill.endShape();

strokeWeight (5);
rolexHourDisk = createShape(ELLIPSE, 0, hourR7, hourDiamDisk, hourDiamDisk);
rolexHourDisk.endShape();

noStroke();
rolexHourY = createShape(); 
rolexHourY.beginShape();
rolexHourY.noStroke();
rolexHourY.vertex(k1X, k1Y);
rolexHourY.vertex(k2X, k2Y);
rolexHourY.vertex(k3X, k3Y);
rolexHourY.vertex(k4X, k4Y);
rolexHourY.vertex(k5X, k5Y);
rolexHourY.vertex(k6X, k6Y);
rolexHourY.vertex(k7X, k7Y);
rolexHourY.vertex(k8X, k8Y);
rolexHourY.vertex(k9X, k9Y);
rolexHourY.fill(color (colorSteel));
rolexHourY.endShape();

fill(colorFluo);
noStroke ();
rolexHourDelta  = createShape(); 
rolexHourDelta.beginShape();
rolexHourDelta .vertex(-6, hourR1+28);
rolexHourDelta .vertex(0, hourR1+11);
rolexHourDelta .vertex(6, hourR1+28);
rolexHourDelta.endShape();

RolexHour.addChild(rolexHourExt);
RolexHour.addChild(rolexHourFill);
RolexHour.addChild(rolexHourDisk);
RolexHour.addChild(rolexHourDelta);
RolexHour.addChild(rolexHourY);
}

////////////////////////////////////

int minR1 = 305 ;//205 ;
int minR2 = 250;//155 ; // Base of external triangle
int minR3 = 40 ; // Base of internal triangle
int minR4 = 10 ; //  Base of origin
int minLarge = 14 ;//12;
int minLargeF = 8 ; //6 ;
int minR5 = 242;//155 ; // Base of external fill
int minR6 = 40; //30 ; // Base of internal fill
int minDiskCenter = 60 ;
void createMinute ()
{
noStroke();

RolexMinute = createShape (GROUP);

fill (colorSteel); // Central disk
strokeWeight (3);
stroke(colorShadow);
rolexMinCenterShadow = createShape(ELLIPSE, 0, 0, minDiskCenter, minDiskCenter); 
rolexMinCenterShadow.endShape();

stroke(colorSteel);
rolexMinDiskRear = createShape(); 
rolexMinDiskRear.beginShape();
rolexMinDiskRear.fill(colorSteel);
rolexMinDiskRear.vertex(0, -minR1);
rolexMinDiskRear.vertex(-minLarge, -minR2);
//rolexMinDiskRear.vertex(-minLarge, -minR2);
rolexMinDiskRear.vertex(-minLarge, -minR3);
rolexMinDiskRear.vertex(0, -minR4);
rolexMinDiskRear.vertex(minLarge, -minR3);
rolexMinDiskRear.vertex(minLarge, -minR2);
rolexMinDiskRear.vertex(0, -minR1);
rolexMinDiskRear.endShape();

rolexMinFill = createShape(); 
rolexMinFill.beginShape();
rolexMinFill.fill(colorFluo);
rolexMinFill.strokeWeight (1);
rolexMinFill.vertex(-minLargeF, -minR5);
rolexMinFill.vertex(-minLargeF, -minR6);
rolexMinFill.vertex(minLargeF, -minR6);
rolexMinFill.vertex(minLargeF, -minR5);
rolexMinFill.endShape();

RolexMinute.addChild(rolexMinCenterShadow);
RolexMinute.addChild(rolexMinDiskRear);
RolexMinute.addChild(rolexMinFill);
}

//////////////////////////////
int secR1 = -320;// -225 ; // Point of external triangle
int secR2 = -176 ;//-125 ; // Base of external triangle
int secR3 = +110; //+79;//-85 ; //  Base of origin, reardisk
int secLarge = 5 ;
int secDiamBackDisk = 18; // Steel
int secDiskMainR = 30; //Fluo
int secDiskCenter = 35; 

void createSecond ()
{
RolexSecond = createShape (GROUP);

rolexSecNeedle = createShape(); 
rolexSecNeedle.beginShape();

fill (colorSteel);  // Center disk and shadow
strokeWeight (2);
stroke(colorShadow);
rolexSecCenterShadow = createShape(ELLIPSE, 0, 0, secDiskCenter, secDiskCenter); 
rolexSecCenterShadow.endShape();

rolexSecNeedle.fill(colorSteel);
rolexSecNeedle.noStroke();
rolexSecNeedle.vertex(-secLarge, +secR3);
rolexSecNeedle.vertex(-secLarge, +secR2);
rolexSecNeedle.vertex(-1, +secR1);
rolexSecNeedle.vertex(1, +secR1);
rolexSecNeedle.vertex(secLarge, +secR2);
rolexSecNeedle.vertex(secLarge, +secR3);
rolexSecNeedle.endShape();

fill(colorSteel);  // Back sec disk
noStroke();
rolexSecRearDisk = createShape(ELLIPSE, 0, secR3, secDiamBackDisk, secDiamBackDisk);
rolexSecRearDisk.endShape();
 
fill(colorFluo);  // External fluo sec disk
strokeWeight (5);
stroke(colorSteel);
stroke(colorSteel);
rolexSecMainDisk = createShape(ELLIPSE, 0, secR2, secDiskMainR, secDiskMainR);
rolexSecMainDisk.endShape();
 
fill (colorShadow);
strokeWeight (3);
stroke(colorSteel);
rolexSecCenterAxis = createShape(ELLIPSE, 0, 0, secDiamBackDisk-8, secDiamBackDisk-8); 
rolexSecCenterAxis.endShape();

RolexSecond.addChild(rolexSecCenterShadow); 
RolexSecond.addChild(rolexSecNeedle);
RolexSecond.addChild(rolexSecRearDisk);
RolexSecond.addChild(rolexSecMainDisk);
RolexSecond.addChild(rolexSecCenterAxis);
}

////////////////////////

void createNeedles()
{
createHour ();
createMinute ();
createSecond();
}

////////////////////////

void redCross()
{
strokeWeight (2);
stroke (colorSteel);
line (width/2,0,  width/2,height);
line (0, height/2,width,height/2); 
noFill ();
/*ellipse (width/2,height/2, -2*hourR1, -2*hourR1);
ellipse (width/2,height/2, -2*hourR2, -2*hourR2);
ellipse (width/2,height/2, -2*hourR3, -2*hourR3);*/
}

////////////////////////

void infos()
{
int posX= 10 ;
int posY= 50;
textSize (32) ;
noStroke ();
fill (#F2145A);
long now = millis();
long duration = now-topTime ;
text("Duration :" , posX+40,posY);
text(duration + " milliSeconds", posX,posY+30);
String clock ="";
if (hour()<9)
    clock ="0";
clock = clock +hour() + ":";
if (minute()<9)
    clock =clock +"0";
clock = clock +minute()+":";
if (second()<9)
    clock =clock +"0";
clock = clock +second();
text (clock, posX+35,posY+80);

topTime=now;
}

////////////////////////

void fulSpeed (int mode)
{  
if (mode==0)   // PC clock
  {
  angleS = 6*second() ;
  angleM = 6*minute() + angleS/60;
  angleH = 30*(hour()%12) + angleM/12;
  }
else  // eratic values
{
  angleH+=.1/12;
  angleM+=.1;
  angleS+=6;
  }
}

////////////////////////
