//*************************************

void introDemos ()
{
demoTriangle () ;
demoCircles ();
demoRotate ();
textDemoGrid ();
demoCheckboard () ;
demoClocks() ;
}

//*************************************

void demoTriangle ()
{
#define loopNumber 300
long topTime=millis();
for (int lp=0; lp<loopNumber; lp++)
  {
  itp.colorLines (random (255), random (255), random (255)) ; // Border
  itp.colorTextFrames (random (255), random (255), random (255)) ; // inside color
  if (lp%2 == 0)
      itp.strokeWeight (random (50)) ;
  else
      itp.noStroke();    // no border
  if (lp%3 == 0)
      itp.noFill (); // empty
  itp.circle (random (xSize), random (ySize), random (200));  
  itp.triangle (random (xSize), random (ySize), random (xSize), random (ySize), random (xSize), random (ySize));  
 // delay (10) ;
  }  
itp.background (204, 204, 0) ; 
itp.colorTextFrames(0, 0, 128) ;
itp.textSize(64) ; 
itp.labelNum (loopNumber, 250,300) ; 
itp.labelText ("loops", 450,300) ; 
itp.labelText ("itp.circles and triangles", 200,100) ; 
itp.labelNum (millis()-topTime, 150, 500) ;
itp.labelText ("milliSeconds", 350,500) ; 
delay (3000);
}
  
//*************************************

void demoCircles ()
{
long topTime=millis();
itp.noFill (); // empty
itp.strokeWeight (1);
itp.background (0,0,0);
for (int lp=xSize/2; lp>2; lp-=2)
  {
  itp.colorLines (random (255), random (255), random (255)) ; // Border
  itp.circle (xSize/2, ySize/2, lp);
  //delay (5) ;
  }
itp.background (204, 204, 0) ; 
itp.colorTextFrames(0, 0, 128) ;
itp.textSize(64) ; 
itp.labelNum (xSize/4, 250,300) ; 
itp.labelText ("loops", 450,300) ; 
itp.labelText ("concentric circles", 200,100) ; 
itp.labelNum (millis()-topTime, 150, 500) ;
itp.labelText ("milliSeconds", 350,500) ; 
delay (3000);
}

//*************************************

void demoRotate ()
{
itp.background (204, 255, 221) ; // Light Green
itp.strokeWeight (4);
for (int lp=0; lp<361; lp+=15)
  {
  itp.colorLines (random (255), random (255), random (255)) ; // Border
  itp.translate(xSize/2, ySize/2); // Rotate around this itp.point
  itp.rotateDeg (lp) ;
  itp.placeImage ("..//fond_Voilec_200.jpg", xSet-375, yRise-50, xSize, ySize );
  //itp.rectangleCorners(-250, -250, 250, 250); // Relative to translate itp.point
  //itp.segment (0, 0, 0, 450);
  delay (100) ; // Don't reduce to avoid transmission bugs !
  }
delay (3000);
}

//*************************************

void textDemoGrid (void)
{
itp.background (128, 204, 0) ; 
itp.colorTextFrames(0, 128, 0) ;
itp.textSize(64) ; 
itp.labelText ("And now grids for", 180,100) ; 
itp.labelText ("various zones to click", 150,180) ; 
itp.labelText ("versus grid resolution", 150,3800) ; 
itp.labelText ("from 3*3  ->   9 areas", 150,520) ; 
itp.labelText ("to 10*10  -> 100 areas", 150,600) ; 
delay (3000);
}

//*************************************

void demoGrid (int red, int green, int blue)
{
itp.colorTextFrames(0, 0, 128) ;
itp.textSize(16) ;
for (int lpX = 10 ; lpX <xSize ; lpX+=10) 
  {
  chooseColor (lpX, 218, 255, 179) ;
  itp.segment (lpX, 0, lpX, ySize);  
  if (lpX%100==0)
      itp.labelNum (lpX/100, lpX, 50);
  }  
for (int lpY = 10 ; lpY <ySize ; lpY+=10) 
  {
  chooseColor (lpY, 218, 255, 179) ;
  itp.segment (0, lpY, xSize, lpY);  
  if (lpY%100==0)
      itp.labelNum (lpY/100, 402, lpY-2);
    }     
}

//*************************************

void chooseColor (int val, int red, int green, int blue)
{
if (val%100==0)
  itp.colorLines (red/8, green/8, blue/8) ; // dark Green
else if (val%50==0)  
  itp.colorLines (red/1.5, green/1.5, blue/1.5) ; // medium Green 
else
  itp.colorLines (red, green, blue) ; // light Green     
}

//*************************************

void demoCheckboard ()
{
for (int resol=3 ; resol<11 ; resol++) // Demo only to show positions of buttons
    demoCheckBoardResol (resol) ;
delay  (3000);
}

//*************************************

void demoCheckBoardResol (int resolution)  // Demo only to show positions of buttons
{
if ((resolution >10) || (resolution == 7) || (resolution == 9) ||(resolution <3))
return ;
 
itp.background (255,255,255) ; // White
demoGrid (204, 153, 255);
delay (100);
itp.textSize (32) ;
itp.strokeWeight (1);
itp.noFill () ;
itp.colorLines (204, 255, 153); // light Green
int  boxX = xSize/resolution;
int  boxY = ySize/resolution ; 
  
for (int lp=0 ; lp< sq(resolution) ; lp++)
  {
  int  rankX = lp%resolution ;
  int  rankY = lp/resolution ;
  int  cornerX = (rankX * boxX) +2 ;
  int  cornerY = (rankY * boxY) +2 ;    
  itp.placeImage ("../North.gif",cornerX+imageOfsetX[resolution-3], cornerY+imageOfsetY[resolution-3], xSize, ySize );  // 10
  itp.colorTextFrames (204, 204, 255); // light Blue
  itp.rectangleDelta (cornerX+rectangleOfsetX[resolution-3], cornerY+rectangleOfsetY[resolution-3], boxX+boxOfsetX[resolution-3], boxY+boxOfsetY[resolution-3]) ; //10
  itp.placeImage ("../North.gif",cornerX+imageOfsetX[resolution-3], cornerY+imageOfsetY[resolution-3], xSize, ySize );  // 10
  itp.colorTextFrames (0, 0, 0); // Black
  itp.segment (cornerX, cornerY, cornerX+boxX, cornerY+boxY) ;
  itp.segment (cornerX, cornerY+boxY, cornerX+boxX, cornerY) ;  
  itp.labelNum (lp, cornerX+labelOfsetX[resolution-3], cornerY+labelOfsetY[resolution-3]) ;  
  }
delay(3000);
}

//*************************************

void checkBoard (int resolution)  // Place active buttons active buttons
{
int  boxX = xSize/resolution;
int  boxY = ySize/resolution ; 
for (int pos=0 ; pos< sizeof (positions) ; pos++)
  {
  int  rankX = positions[pos]%resolution ;
  int  rankY = positions[pos]/resolution ;
  int  cornerX = (rankX * boxX) +2 ;
  int  cornerY = (rankY * boxY) +2 ;  
itp.placeImage ("../North.gif",cornerX+imageOfsetX[resolution-3], cornerY+imageOfsetY[resolution-3], xSize, ySize );  // 10
itp.placeImage ("../South.gif",cornerX+imageOfsetX[resolution-3], cornerY+boxY+imageOfsetY[resolution-3], xSize, ySize );  // 10
  }

/*itp.colorTextFrames(102, 153, 0); // Medium green
itp.textSize (32) ; 
for (int pos=0 ; pos< sq(resolution) ; pos++) // Mark icons grid positions
  {
  int  rankX = pos%resolution ;
  int  rankY = pos/resolution ;
  int  cornerX = (rankX * boxX) +2 ;
  int  cornerY = (rankY * boxY) +2 ;  
  itp.labelNum (pos, cornerX+labelOfsetX[resolution-3], cornerY+labelOfsetY[resolution-3]) ;  
  }*/
}

//*************************************
int oldSecNeedle ;

void needle (int posX, int posY, int ray) // Center
{
#ifdef DS3231
DateTime now = rtc.now();
if (oldSecNeedle== now.second())
return;
oldSecNeedle = now.second();
#endif

itp.colorTextFrames (128, 179, 255); // blue
itp.rectangleDelta(posX-ray, posY-ray, 2*ray, 2*ray);
itp.colorLines (204, 255, 153); // light Green
itp.fillForm(204, 255, 153); // light Green
for (int angle =0; angle <360; angle +=6)
  {
  float gr = (180-angle)*PI/180;
  if (angle%90!=0)
      itp.point (posX+(ray-2)*sin (gr), posY+(ray-2)* cos (gr));
  else
      itp.segment(posX+ray*.7*sin (gr), posY+ray*.7*cos (gr), posX+ray*sin (gr), posY+ray *cos (gr)); 
  }

itp.circle (posX, posY,10);

itp.strokeWeight (5);

#ifdef DS3231
float gr = (180-(6*now.second()))*PI/180;
#else
float gr = random (360);
#endif
itp.segment (posX, posY, posX+ray*sin (gr), posY+ray* cos (gr));
}

//*************************************

void demoClocks()
{
int oldX=5, oldY=20;
int k=4;
itp.background (204, 255, 255) ; // Light Blue
getTimeNow ();
for (float fontSizeClock=8; fontSizeClock<400; fontSizeClock*=1.2)
{
if (oldX > 800) //(900-(fontSizeClock * (k+1))))
    {
    oldX= 2*fontSizeClock;
    int delta = .8*fontSizeClock;
    oldY +=delta;
    }
//sprintf (buffer, "Font = %d     X=%d   Y=%d", fontSizeClock, oldX, oldY);
//Serial.println (buffer);
  
  placeClock (oldX, oldY, fontSizeClock) ;
  int delta = k *fontSizeClock;
  oldX += delta;
  }
delay (3000);
}

//*************************************
