//***********************************//
//        Curve  Processing          //
//***********************************//
//        Christian Couderc          //
//         www.voilec.com            //
//***********************************//
//   220204

int width = 800 ;
int height = 800 ;
float xC  =width/2 ;
float yC  =height/2 ;
float ray = xC-5;
float moonCycle=29.5;
PImage img;
float angleStart, angleStop ;
PShape shadow;

// **************************************************
void settings()
{size (width, height);}
// **************************************************
void setup() 
{
img =loadImage ("..//FullMoon_800.jpg");
strokeWeight (2);
stroke (255);
textSize(32);
ellipseMode(RADIUS);
}
// **************************************************
void draw() 
{
image(img, 0, 0);
float day= moonCycle*(width-mouseX)/width;
float pos= ray*2*(width-mouseX)/width;
noStroke();
fill(255, 0, 0);
text ("day :", 10, 40);
text (int(day), 80, 40);
text ("pos : ", 10, 80);
text (int(pos), 80, 80);

if (pos<xC)   // <------------ It's good!
    {
    stroke (255,0,0);
    line (pos, height-50, pos, height);
    stroke (0,255,0); 
    angleStart=90;
    angleStop= 270 ; 
    fill (32); // grey shadow
    arc (xC,yC,  ray-pos,ray,  radians(angleStart), radians(angleStop),OPEN)       ; // moving

    angleStart=-90;
    angleStop= 90 ;      
    arc (xC,yC,  ray,ray,  radians(angleStart), radians(angleStop),OPEN)       ;  // fix                                   
    }
else
    {
    createShadow(pos);
    }
line (xC,0,xC,height);
}
// **************************************************
void createShadow(float pos)
{
fill (32); // grey
stroke (0,255,0);
line (pos, height-50, pos, height);
    
beginShape();
   angleStart= -90;
   angleStop= 90;                                  
    fill (32); // grey shadow
  arc (xC,yC,  ray,ray,  radians(angleStart), radians(angleStop),OPEN)       ;  // fix
 //  noFill();
   angleStart= -90;
   angleStop= +90;       

   fill(255, 0, 0);  // <--RED  Need to suppress this red part, only need black shadow!
   arc (xC,yC,  pos-ray,ray,   radians(angleStart), radians(angleStop),OPEN)       ; // moving
endShape();
}
// **************************************************
