// ATtiny Blackout

// ATMEL ATTINY45 / ARDUINO
//
//                  +-\/-+
// Ain0 (D 5) PB5  1|    |8  Vcc
// Ain3 (D 3) PB3  2|    |7  PB2 (D 2) Ain1
// Ain2 (D 4) PB4  3|    |6  PB1 (D 1) pwm1
//            GND  4|    |5  PB0 (D 0) pwm0
//                  +----+

// *****************************

//  PB5  // 1 nc
//  PB3  // 2 nc
// 4 GND
// 8 Vcc 3.3 V


#define BkOutput    0 //PB0  // Active Hight outputs via diodes
#define InfraRed    1 //PB1  // Active Hight  -> 0 = nobody
#define Radar       2 // PB2  // Active Hight -> 0 = nobody
#define LedBlueInfo 4 //PB4  // Infomation flashing light :  3.3 kOhms to LED anode

#define tempo 120  // Tempo 2 minutes in second
int count, bkSec, sec10 ; 
byte sensors ;


// *****************************
// *****************************

void setup()
{
pinMode(BkOutput, OUTPUT)         ; //  PB0 low = sleep order
pinMode(InfraRed, INPUT_PULLUP)   ; //  PB1 low = no detection
pinMode(Radar, INPUT_PULLUP)      ; //  PB2 low = no detection
pinMode(3, OUTPUT)                ; //  PB3 NOT used
pinMode(LedBlueInfo, OUTPUT)      ; //  PB4 Infomation flashing light
pinMode(5, OUTPUT)                ; //  PB5 NOT used, stability, low sortance??   

count = tempo*10 ; // Reset counter
orders (1) ;
}

// *****************************
// *****************************

void loop() 
{  
sensors = digitalRead (InfraRed) ;
if (sensors != 0)     // Mouvement
  {
  if (count<10)  
      restartFlash () ;

  count = tempo*10 ; // Reset counter    
  }


sec10 = (millis () /100)%100 ;
if (bkSec != sec10) // New 1/10 sec
        {
        bkSec = sec10 ;  // 0 .. 99


      
/*   if((bkSec == 0) && (count > tempo*5)) // Small flash every 10 seconds
            invertBlueLed (20) ; */

        if (bkSec == 0) // New 10 second
           {
      digitalWrite (BkOutput, 0) ; 
      delay (500) ;
      digitalWrite (BkOutput, 1) ; 
      
      for (int x=count/100 ; x>0 ; x-- )          
                invertBlueLed (200) ;
            }
                
        if (count == 0)
              orders (0) ;
        else
              count-- ;  // 1/10 sec
        }        
 }

// *****************************
// *****************************

void restartFlash ()
{
orders (1) ;
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++  

void orders (byte level)
{
digitalWrite (BkOutput, level) ; // 
digitalWrite (LedBlueInfo, level); // 
}


// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++  

void invertBlueLed (byte timing)
{
byte val = digitalRead (LedBlueInfo) ;
digitalWrite (LedBlueInfo, !val) ; 
delay (timing) ;    
digitalWrite (LedBlueInfo, val) ;
delay (timing) ;  
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++   
