/*
Durée d'affichage pour un million de boucles:

Esp32       =    1284 ms
Teensy 3.2  =     480 ms/72Mhz 360 ms/96 Mhz 288 ms/120Mhz
STM32 B8    =     655 ms
Due         =    2247 ms
Uno         =    5282 ms
Leonardo    =    7587 ms
AT Mega     =    7798 ms
Nano        =    5313 ms
*/

// the setup function runs once when you press reset or power the board


int oneLed = 13 ;
unsigned long timeTemp ;
byte a,b;


#define nb 1000000
void setup() 
{
while (!Serial) ; //Leonardo
Serial.begin(115200) ;

pinMode(oneLed, OUTPUT);

Serial.print  ("Test en cours pour  ");
Serial.print(nb);
Serial.println("  boucles\n");
timeTemp = millis () ;
showTime (timeTemp) ;
 
for (long i = nb ; i>0 ; i--)
    digitalWrite(oneLed, i%2);
  
showTime (millis () - timeTemp) ;
  
}

/////////////////////////////////////

void loop() 
{
digitalWrite(oneLed, ! digitalRead (oneLed) );   
delay(100);                      
}

/////////////////////////////////////

void showTime (unsigned long t)
{
Serial.print ("Time :  ") ; 
Serial.print (t) ;  
Serial.print (" millisec\n") ;   
}
