#include "Nextion.h"


***********************  
*                     *
*  Christian Couderc  *
*                     * 
*   www.voilec.com    *
*                     *   
***********************  

//#define prt // debug print

//  *****************************   Instanciate (declare) all objects : page ID,  component ID , name
NexPage pageIntro = NexPage (0,0,"pageIntro");
NexPage pageMain = NexPage (1,0,"pageMain");
NexPage pageGraph = NexPage (2,0,"pageGraph");
NexPage pageConfig = NexPage (3,0,"pageConfig");
NexPage pageRiver = NexPage (4,0,"pageRiver");
NexButton bM0 = NexButton (1,10,"bM0");
NexButton bM5 = NexButton (1,13,"bM5");
NexButton bM6 = NexButton (1,11,"bM6");
NexButton bC0 = NexButton (3,1,"bC0");
NexVariable posX0 = NexVariable (2,1,"posX0");
NexVariable posY0 = NexVariable (2,2,"posY0");
NexVariable sizeX = NexVariable (2,3,"sizeX");
NexVariable sizeY = NexVariable (2,4,"sizeY");
NexText tM1 = NexText(1,6,"tM1");
NexText tMt1 = NexText(1,17,"tMt1");
NexText tM2 = NexText(1,7,"tM2");
NexText tMt2 = NexText(1,16,"tMt2");
NexText tM3 = NexText(1,8,"tM3");
NexText tMt3 = NexText(1,15,"tMt3");
NexText tM4 = NexText(1,9,"tM4");
NexText tMt4 = NexText(1,13,"tMt4");
NexText tM5 = NexText(1,4,"tM5");
NexText tM6 = NexText(1,5,"tM6");
NexText tM7 = NexText(1,12,"tM7");
NexText tG0 = NexText(2,6,"tG0");
NexText tG1 = NexText(2,10,"tG1");
NexText tG2 = NexText(2,9,"tG2");
NexText tG3 = NexText(2,7,"tG3");
NexText tG6 = NexText(2,8,"tG6");
NexText tC0 = NexText(3,3,"tC0");
NexText tC6 = NexText(3,5,"tC6");
NexSlider sliderLum = NexSlider (3,2,"sliderLum");
NexHotspot hotI = NexHotspot (0,1,"hotI");
NexHotspot hotG = NexHotspot (2,1,"hotG");
NexHotspot mM1 = NexHotspot (1,20,"mM1");
NexHotspot mM2 = NexHotspot (1,19,"mM2");
NexHotspot mM3 = NexHotspot (1,18,"mM3");
NexHotspot mM4 = NexHotspot (1,14,"mM4");

// *****************************    Register objects to the touch event list
// https://github.com/itead/ITEADLIB_Arduino_Nextion/blob/master/examples/CompHotspot/CompHotspot_v0_32.ino

NexTouch *nex_listen_list[] = 
{
  &pageIntro,  &pageMain,  &pageGraph,  &pageConfig,
  &bM0,  &bM5,  &bM6,
  &tM1,  &tM2,  &tM3,  &tM4,  &tM5,  &tM6,
  &bC0,
  &tC0,  &tC6,
  &sliderLum,
  &hotI,  &hotG, &mM1,  &mM2,  &mM3,  &mM4,
  NULL
};

// *****************************   Creating Callbacks  

// ******* pop ******

void pageIntroPopCallback(void *ptr)
{
    dbSerialPrintln("pageIntroPopCallback");
    pageIntro.show();
        dbSerialPrintln ("\n*********** page pop Intro\n") ;
}

void pageMainPopCallback(void *ptr)
{
    dbSerialPrintln("pageMainPopCallback");
    pageMain.show();
}

void pageGraphPopCallback(void *ptr)
{
    dbSerialPrintln("pageGraphPopCallback");
    pageGraph.show();
}

void pageConfigPopCallback(void *ptr)
{
    dbSerialPrintln("pageIntroPopCallback");
    pageIntro.show();   
}

void bM0PopCallback(void *ptr)
{
    dbSerialPrintln("bM0PopCallback"); 
    dbSerialPrint("ptr=");
    dbSerialPrintln((uint32_t)ptr);
showGraphicPage (0) ; // switch to <Graph Press> 
}
void mM1PopCallback(void *ptr)
{
    dbSerialPrintln("mM1PopCallback"); 
    dbSerialPrint("ptr=");
    dbSerialPrintln((uint32_t)ptr);
showGraphicPage (1) ; // switch to <Graph Salon>
}
void mM2PopCallback(void *ptr)
{
    dbSerialPrintln("mM2PopCallback");
    dbSerialPrint("ptr=");
    dbSerialPrintln((uint32_t)ptr);
showGraphicPage (2) ; // switch to <Graph Nord> pa
}

void mM3PopCallback(void *ptr)
{
    dbSerialPrintln("mM3PopCallback");
    dbSerialPrint("ptr=");
    dbSerialPrintln((uint32_t)ptr);
showGraphicPage (3) ; // switch to <Graph Bureau> 
}

void mM4PopCallback(void *ptr)
{
    dbSerialPrintln("mM4PopCallback"); 
    dbSerialPrint("ptr=");
    dbSerialPrintln((uint32_t)ptr);
showGraphicPage (4) ;   // switch to <Graph Radiateur> 
}

void bM5PopCallback(void *ptr)
{
    dbSerialPrintln("bM5PopCallback"); // bouton <Quantieme> de main
    dbSerialPrint("ptr=");
    dbSerialPrintln((uint32_t)ptr);
send_to_nextion("page pageIntro") ;   // switch to <Intro> panel
}

void bM6PopCallback(void *ptr)
{
    dbSerialPrintln("bM6PopCallback"); // bouton <Horloge> de main
    dbSerialPrint("ptr=");
    dbSerialPrintln((uint32_t)ptr);
send_to_nextion("page pageConfig") ; // switch to <Config> panel  
placeConfig ();
}

void bC0PopCallback(void *ptr)
{
    dbSerialPrintln("bC0PopCallback"); // bouton <return Main> de config
    dbSerialPrint("ptr=");
    dbSerialPrintln((uint32_t)ptr);
createMain (); //Place values for main screen    
}

void hotIPopCallback(void *ptr)
{
    dbSerialPrintln("hotIPopCallback"); // Appui sur fenetre Intro
    dbSerialPrint("ptr=");
    dbSerialPrintln((uint32_t)ptr);
createMain (); //Place values for main screen
}

void hotGPopCallback(void *ptr)
{
    dbSerialPrintln("hotGPopCallback"); // Appui sur fenetre Graph
    dbSerialPrint("ptr=");
    dbSerialPrintln((uint32_t)ptr);
createMain ();
}

void sliderLumPopCallback(void *ptr)
{
    uint32_t number = 0;
    char temp[10] = {0};   // ??????????????? 
    dbSerialPrintln("h0PopCallback");
sliderLum.getValue(&number);
utoa(number, temp, 10);
tC0.setText(temp);
}

// ******* push ******

/*void bM0PushCallback(void *ptr)
...
void sliderLumPopCallback(void *ptr) */
  
// *****************************  Display parameters
 
#define resolX 800   // Size of display 3.5" = 480x320  7"=800x480
#define resolY 480 
#define X0  77  // Plot area positions 3.5"
#define Y0  55
#define Xs  720
#define Ys  390  
#define OffsetPress 90000

#define INTERVAL_MIN     4  // Delay between records in minutes
#define RECORDS_BY_DAY 360  // 24 * 60 / INTERVAL_MIN 
// 
byte nHour,nMin,nSec ; // Clock
uint16_t BufEep360[360] ;
int topTime ;
long chrono ;
int16_t offMinD , stepOff, nbStepsY , offs, vari  ;

#define curveDays 1
//uint8_t buffer[40] = {0};
char showTop [5]  ; // Time from topTime same as <12:34>
char showHMS [10] ; // Clock> "23:59:59" 
char temp[10] = {0} ;
String cmd ="";
#define DataSize 0  // 
int transfert [DataSize+20] ;

/*#define OffsetHH      DataSize+0 // Hour
#define OffsetMM      DataSize+1 // Min
#define OffsetSS      DataSize+2 // Sec*/
#define OffsetSens0   DataSize+3 // Press
#define OffsetSens1   DataSize+4 // Salon  // 2134 = 2135 -> 21.3 // 2136 -> 21.4
#define OffsetSens2   DataSize+5 // Nord
#define OffsetSens3   DataSize+6 // Bureau
#define OffsetSens4   DataSize+7 // radiateur
#define OffsetQuant   DataSize+8 // Quantieme
#define OffsetChannel DataSize+9 // Sensors channel
#define OffsetAlti    DataSize+10 // Presure
/*#define OffsetWeekday DataSize+11 // Dimanche...Samedi
#define OffsetDay     DataSize+12 // 1...31
#define OffsetMonth   DataSize+13 // Janvier... Decembre
#define OffsetYear    DataSize+14 // 18 -> 2018*/
#define OffsetLastVal DataSize+15 // raw from sensor
// to be found in  board_xx.h
const char*  DAY[] = {"Dimanche", " Lundi  "," Mardi  ","Mercredi"," Jeudi  ","Vendredi"," Samedi "};  // 8 car
const char*  MON[] = {"Janvier ","Fevrier ","Mars  ","Avril  ","Mai  ","Juin  ","Juillet ","Aout  ","Septembre","Octobre","Novembre","Decembre"};  // 3 a 9
const char USBOUT[][6] = {"QNH","hPa","Salon","C","Nord","C","Bureau","C","Radiat","C","RTC","S","BMP280","C","Batt.","V"} ; 
const char* usbout = "" ;
String clkMain = "bM6" ;
String clkGraph = "tG6" ;
String clkConfig = "tC6" ;

// **************************************
// **************************************

void setup() 
{
randomSeed(analogRead(0));

//nexSerial.begin(115200);  // Start serial comunication to Nextion at baud=115200  
//nexSerial.begin(9600);  // 
//delay(500);  // This delay is just in case the nextion display didn't start yet, to be sure it will receive the following command.
nexInit();  // Initialisation de la librairie ITEAD pour Nextion.
delay (3) ;
//delay(500);
nexSerial.begin(115200);
delay(500);
Serial.begin(115200);  // Start serial comunication at baud=115200 : Must to be AFTER nexInit !!
dbSerialPrintln ("\n\n\n\n\n\n\n\n\n\nTest Nextion\n\n"); 
pageIntro.attachPop(pageIntroPopCallback);
pageMain.attachPop(pageMainPopCallback);
pageGraph.attachPop(pageGraphPopCallback);
pageConfig.attachPop(pageConfigPopCallback);
// Register the pop event callbacks function of the current number component in Setup

bM0.attachPop(bM0PopCallback,&bM0);
bM5.attachPop(bM5PopCallback,&bM5);
bM6.attachPop(bM6PopCallback,&bM6);
bC0.attachPop(bC0PopCallback,&bC0);
hotI.attachPop(hotIPopCallback,&hotI);
hotG.attachPop(hotGPopCallback,&hotG);
mM1.attachPop(mM1PopCallback,&mM1);
mM2.attachPop(mM2PopCallback,&mM2);
mM3.attachPop(mM3PopCallback,&mM3);
mM4.attachPop(mM4PopCallback,&mM4);
//sliderLum.attachPop(sliderLumPopCallback);

send_to_nextion ("tM1.setText\(\" \"\)") ; // Very important to awake Nextion
    dbSerialPrintln("PageIntro final"); 
send_to_nextion("page pageRiver") ; 
    dbSerialPrintln("Page River"); 
delay (2000) ;
send_to_nextion("page pageIntro") ;
    dbSerialPrintln("Page Intro");  
}
   
// **************************************

void loop() 
{
nexLoop(nex_listen_list);
}

// **************************************
// **************************************

void showGraphicPage (byte sensorNumber)  // Construction plotting area
{
dbSerialPrint ("\nGraph page, Sensor Number = ");
dbSerialPrintln (sensorNumber);
createDemoCurve (sensorNumber); // Simulation metier
// Le <metier> traite tous les capteurs, gere l'historique et fabrique la automatiquement liste des donnees
// La partie <IHM Nextion> pointe sur cette liste seulement, totalement independament du metier
// Interaction principale : <IHM> passe a <Metier> le numero du capteur a afficher pour mise a jour de la liste. 
// Interactions secondaires: dans <configuration> passage de quelques paramètres : Mise à l'heure horloge, nombre de jours...
chrono = millis() ;
//displayHMS (clkGraph) ; // Place clock

createPlotZone ();
cmd = "createPlotZone" ; // 3 mS
printTop (cmd) ;

placeAbcisseX (topTime) ;// Lignes verticales et graduations échelle X, heures ou jours : Exemple relative sur 24 heures : |16|18|20|22||0 ..|14|
cmd = "placeAbcisseX" ; // 122 mS -> 88 mS sans print
printTop (cmd) ;

placeOrdoneeY (sensorNumber, nbStepsY) ; // Place étiquettes pressions et quadrillage des ordonnées
cmd = "placeOrdoneeY" ; // 73/8 mS     -> 37/4 sans print
printTop (cmd) ;

placeCurveDays () ; // 
cmd = "placeCurveDays" ; // 3 mS
printTop (cmd) ;

placeGraphUnits (sensorNumber) ; // Place étiquettes pressions et quadrillage des ordonnées
cmd = "placeGraphUnits" ; // 3 mS
printTop (cmd) ;

placeLastValue (123456) ; // 
cmd = "placeLastValue" ; // 3 mS
printTop (cmd) ;

plotCurve () ; // Place 360 points  
cmd = "plotCurve" ; //  742 mS (2 times=1484 // 3 times=2228 // 4 times=2970): Calculation < 1 mS
printTop (cmd) ;

placeGraphName (sensorNumber) ; // Place étiquettes pressions et quadrillage des ordonnées
cmd = "placeGraphName" ; // 3 mS
printTop (cmd) ;
}

//////////////////////////

void printTop (String mess)
{
Serial.print ("Timing from : ") ;
Serial.print (mess) ;
Serial.print (" = ") ;
Serial.print (millis()-chrono) ;
Serial.println (" milliSeconds\n") ;
chrono = millis() ;
}

//////////////////////////
  
void createPlotZone ()
{
cmd = "fill "; // Background zone
cmd += (X0);
cmd += (",");
cmd += (Y0);   
cmd += (",");
cmd += (Xs);
cmd += (",");
cmd += (Ys);
cmd += (","); 
cmd += (65304);
send_to_nextion(cmd) ;   

cmd = "draw "; // Frame zone
cmd += (X0-2);
cmd += (",");
cmd += (Y0-2);   
cmd += (",");
cmd += (Xs+X0+4);
cmd += (",");
cmd += (Ys+Y0+4);
cmd += (","); 
cmd += (2016); //Green
send_to_nextion(cmd) ; 
}

//////////////////////////

void plotCurve (void) // Place 360 points in place in buffer
{ 
int yOld = Ys-BufEep360[(Xs/2)-1] ; //359
int y = yOld ;
placeLastMark (y+Y0) ; // Right collumn, last record = [359]
for(int x=(Xs-2)/2 ; x>=0 ; x--)
  {
  y = (Ys-BufEep360[x]) ;  
   
//  String cmd = String("line ");
  cmd = "line ";
  cmd += ((2*x)+1+X0);
  cmd += (",");
  cmd += (yOld+Y0);   
  cmd += (",");
  cmd += ((2*x)+X0);
  cmd += (",");
  cmd += (y+Y0);
  cmd += (",0") ; //Black
  send_to_nextion(cmd) ;    
  yOld = y ;
  }

cmd = ("\nCurve completed in ");
printTop (cmd);
}

//////////////////////////

void getTopTime (int topTime)
{
// topTime 0..(24*60)-1 // 0..(1440-1)
int h = topTime / 60 ; // 0..23
int m = topTime % 60 ; // 0,4,8,..52,56
showTop[0] = '0'+ (h/10) ;
showTop[1] = '0'+ (h%10) ;
showTop[2] = ':' ;
showTop[3] = '0'+ (m/10) ;
showTop[4] = '0'+ (m%10) ;
}

//////////////////////////

/*void displayHMS (String butName)
{
int hh = transfert [OffsetHH] ;
int mm = transfert [OffsetMM] ;
int ss = transfert [OffsetSS] ;
showHMS[0] = '0'+ (hh/10) ;
showHMS[1] = '0'+ (hh%10) ;
showHMS[2] = ':' ;
showHMS[3] = '0'+ (mm/10) ;
showHMS[4] = '0'+ (mm%10) ;
showHMS[5] = ':' ;
showHMS[6] = '0'+ (ss/10) ;
showHMS[7] = '0'+ (ss%10) ;
cmd = butName ;
cmd += (".txt=\"") ;
cmd += showHMS ;
cmd += ("\"");
send_to_nextion(cmd) ;
Serial.println(cmd) ;
}*/

//////////////////////////

void placeAbcisseX (int timeNow) // 0..(1440-1)
{
timeNow = 0 ; //720 ;//0 ;  
Serial.print ("\n  TopTime = ");
Serial.print (timeNow);
Serial.print ("\t H= ");
Serial.print (timeNow/60);
Serial.print ("\t M = ");
Serial.println (timeNow%60);

int offset = timeNow / (4*curveDays) ; // 0..359*2  in 4 minutes
for (int hr = 0 ; hr<24 ; hr+=2) // Number of verticals ZONEX360 = 360  // Marks every 2 hours
  {
//  int posX = X0 +( Xs - 4 +(hr * 30) + ((timeNow%60)/2))%Xs ; // Two pixels for 4 min 
//  int posX = X0 +( Xs + 4 +(hr * 30) + (timeNow/2))%Xs ; // Two pixels for 4 min 
  int posX = X0 +( Xs + 2 +(hr * 30) + (timeNow/2))%Xs ; // Two pixels for 4 min 
 #ifdef prt
              Serial.print ("posX = ");
              Serial.print (posX); 
              #endif
uint16_t colrX = 57084 ; //GRAY ;
if (hr==0)
    colrX = 63488 ; //RED ;
else if (hr==12)
    colrX = 65504 ; //YELLOW ;
    
  placeMarkX (hr, posX, colrX) ;
              #ifdef prt
              Serial.print ("    placeMarkX  ");   
              #endif  
  cmd = "line " ;
  cmd += (posX);
  cmd += (",");
  cmd += (Y0);
  cmd += (",");
  cmd += (posX);
  cmd += (",");
  cmd += (Y0+Ys);
  cmd += (",");
  cmd += (colrX);
  send_to_nextion(cmd) ; 
              #ifdef prt
              Serial.println (cmd);  
              #endif  
  }
}

//////////////////////////

void placeMarkX (int hr, int posiX, uint16_t color)
{ 
itoa(hr, temp ,10) ; // Convert int to string    
              #ifdef prt
              Serial.print (" \thr = "); 
              #endif  
cmd = "tG1.txt=\"" ;  // Place numeric label
cmd += (temp) ; 
cmd += ("\"") ;
send_to_nextion(cmd) ;
              #ifdef prt
              Serial.print (temp);  
              #endif   

//xstr <x>,<y>,<w>,<h>,<fontid>,<font color>,<back color>,<xcen>,<ycen>,<sta>,<text>
//nexSerial.print("xstr 0,220,200,50,0,YELLOW,BLACK,1,1,1,t1.txt") ;

cmd = "xstr " ;
cmd += (posiX-16);
cmd += (",") ;
cmd += (resolY-29);
cmd += (",40,28,1,0,") ; // Black
cmd += color ;
cmd += (",1,1,1,tG1.txt");
send_to_nextion(cmd) ;   
              #ifdef prt
              Serial.print ("   \tlabel : ");
              Serial.print (cmd);
              #endif      
}

//////////////////////////

void placeOrdoneeY (byte type, byte nbStepsY)   // Place étiquettes pressions ou temperatures et quadrillage des ordonnées
{
//  type : not used now, only for final version !
int value = offMinD ;
for (int y=0; y<=nbStepsY ; y++)
  {
  value = offMinD + (y * stepOff) ;
  int z = Y0 + + Ys - (y * (Ys/nbStepsY)) ;
  if ((z != 0) && (z != nbStepsY))
    {
    String cmd = String("line ") ;
    cmd += (X0);
    cmd += (",");
    cmd += (z);
    cmd += (",");
    cmd += (X0+Xs);
    cmd += (",");
    cmd += (z);
    cmd += (",RED");
    send_to_nextion(cmd) ;   
              #ifdef prt
              Serial.print ("Horizontal :   ");
              Serial.print (value);
              Serial.print (" \t");
              Serial.print (cmd);
              #endif  
    }  
  placeMarkY (value , z) ;
  }  
}

//////////////////////////

void placeMarkY (int val, int posiY)
{

cmd = ("tG1.txt=\"") ;  // Place numeric label
if (val>32765)
{
cmd += "-" ;   
val -= 32765 ;
}
utoa(val/100 , temp ,10) ; // Convert int to string
cmd += (temp) ; 
if (val%100 !=0) // 10,25,50
  {
  cmd += (".") ; 
  if (val%10 == 0)
       utoa((val%100)/10 , temp ,10);
  else
       utoa(val%100 , temp ,10);
  cmd += (temp) ;              
  }
cmd += ("\"") ;
send_to_nextion(cmd) ;

//xstr <x>,<y>,<w>,<h>,<font>,<pco=font color>,<bco=back color>,<xcen=h align>,<ycen>,<sta=backgd>,<text>
//send_to_nextion("xstr 0,220,200,50,0,YELLOW,BLACK,1,1,1,tG1.txt") ;
cmd = "xstr 0," ;
cmd += (posiY-15);
cmd += (",80,30,1,WHITE,BLUE,1,1,1,tG1.txt");
send_to_nextion(cmd) ;   
              #ifdef prt
              Serial.print (" \t\t");
              Serial.println (cmd);
              #endif                
}

//////////////////////////

void placeLastMark (int poslY) // Right collumn
{
cmd = "cirs " ; // cirs x, y, ray, color
cmd += (resolX-10);
cmd += (",");  
cmd += (poslY);
cmd += (",10,RED"); 
send_to_nextion(cmd) ; 
}
////////////////////////// 

void placeCurveDays ()
{
if (curveDays==1)
    cmd = "tG2.txt=\"--*--\"" ; 
else if (curveDays==2)
    cmd = "tG2.txt=\"-*-*-\"" ; 
else
    cmd = "tG2.txt=\"**-**\"" ;     
send_to_nextion(cmd) ;
}

////////////////////////// 

void placeGraphUnits (byte sensorNumber)
{
cmd = "tG0.txt=\"" ; 
usbout = USBOUT [1+(2*sensorNumber)] ;  
cmd+= usbout ;
cmd+= "\"" ;
send_to_nextion(cmd) ;
}

////////////////////////// 

void placeGraphName (byte sensorNumber)
{
char temp[10] = {0} ;
cmd = "tG1.txt=\"" ; 
usbout = USBOUT [2*sensorNumber] ;  
cmd+= usbout ;
cmd+= "\"" ;
send_to_nextion(cmd) ;
}

////////////////////////// 

void placeLastValue (long val)
{
char temp[10] = {0} ;
utoa(val/100 , temp ,10) ; // Convert int to string
cmd = ("tG3.txt=\"") ;  // Place numeric label
cmd += (temp) ; 
if (val%100 !=0) // 10,25,50
  {
  cmd += (".") ; 
  if (val%10 == 0)
       utoa((val%100)/10 , temp ,10);
  else
       utoa(val%100 , temp ,10);
  cmd += (temp) ;              
  }
cmd += ("\"") ;
send_to_nextion(cmd) ;
}

//////////////////////////
//////////////////////////
//////////////////////////

void send_to_nextion(String command) // Sends nextion string and terminates it
{
nexSerial.print(command);
nexSerial.write(0xFF);
nexSerial.write(0xFF);
nexSerial.write(0xFF);
}

//////////////////////////

void createMain ()
{    
chrono=millis();
SimulateMainDatas() ; // Metier: randomize data factory
cmd = ("<<<< SimulateMainDatas >>>>") ;
printTop(cmd) ;

placeQuant () ;
placeChannelId () ;  // Channel : 1 car

//displayHMS (clkMain) ;
//placeCalendar () ; // Mercredi 21 Novembre 2018
placeMainPress () ; // 1013.15 hPa
placeMainAlti ()  ; // Altitude val
placelabel4Sensors ();
placeMain4Sensor (1 , OffsetSens1) ; // Salon val
placeMain4Sensor (2 , OffsetSens2) ; // Nord val
placeMain4Sensor (3 , OffsetSens3) ; // Bureau val
placeMain4Sensor (4 , OffsetSens4) ; // Chaudiere val
cmd = ("/// Main OK ///") ;
printTop(cmd) ;
}


// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void placeQuant ()   // Channel : 1 car
{
String cmd = ("bM5.txt=\"") ;  // Quantieme : 3 car
cmd += (transfert [OffsetQuant]) ; 
cmd += ("\"") ;
send_to_nextion(cmd) ;
  dbSerialPrintln(cmd);
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void placeChannelId ()   // Channel : 1 car
{
String cmd = ("tM5.txt=\"") ;  // Channel : 1 car
cmd += (transfert [OffsetChannel]) ; 
cmd += ("\"") ;
send_to_nextion(cmd) ;
  dbSerialPrintln(cmd);
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void placeMainPress ()  // 1013.15 hPa
{
String cmd = ("bM0.txt=\"") ;  // Press : 11 car
int varH = (OffsetPress + transfert [OffsetSens0])/100 ;
int varL = transfert [OffsetSens0]%100 ;
cmd += (varH) ; 
cmd += (".") ; 
cmd += (varL) ; 
cmd += (" hPa\"") ;
send_to_nextion(cmd) ;
  dbSerialPrintln(cmd);
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

/*void placeCalendar () // Mercredi 21 Novembre 2018
{
//String  cmd = ("tM6.txt=\"Mercredix21xNovembre 2018\"") ;  // Calendar : 28 car
String  cmd = ("tM6.txt=\"") ; // Calendar : 28 car : Mercredi 21 Novembre 2018 
const char*  DAY[] = {"Dimanche", " Lundi  "," Mardi  ","Mercredi"," Jeudi  ","Vendredi"," Samedi "};  // 8 car 
const char *part = NULL ;
part = DAY[OffsetWeekday];

const String  DAYLIST[] = {"Dimanche","Lundi","Mardi","Mercredi","Jeudi","Vendredi","Samedi"}; 
int indx = transfert [OffsetWeekday] ;
String part = DAYLIST[indx] ; 
cmd += (part) ; 
cmd += (" ") ; 
cmd += (OffsetDay) ;
cmd += (" ") ; 
const char*  MON[] = {"Janvier ","Fevrier ","Mars  ","Avril  ","Mai  ","Juin  ","Juillet ","Aout  ","Septembre","Octobre","Novembre","Decembre"}; 3 a 9
//part = MON[OffsetMonth];
//cmd += (part) ; 

const String  MONLIST[] = {"Janvier","Fevrier","Mars","Avril","Mai","Juin","Juillet","Aout","Septembre","Octobre","Novembre","Decembre"}; // 3 a 9
indx = transfert [OffsetMonth] ;
part = MONLIST[indx] ; 
cmd += (part) ; 
cmd += (" ") ;
cmd += (transfert [OffsetYear]) ; 
cmd += ("\"") ;
send_to_nextion(cmd) ;
  dbSerialPrintln(cmd); 
}*/

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void placeMainAlti    ()   // Altitude val
{
String  cmd = ("tM7.txt=\"") ; // Altitude val : 8 car
cmd += (transfert [OffsetAlti]) ; 
cmd += (" m\"") ;   
send_to_nextion(cmd) ;
  dbSerialPrintln(cmd); 
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void placelabel4Sensors    ()   // Altitude val
{
cmd = ("tMt1.txt=\"Salon      :\"") ;  // Salon label : 12 car
send_to_nextion(cmd) ; 
cmd = ("tMt2.txt=\"Nord       :\"") ;  // Nord label : 12 car
send_to_nextion(cmd) ; 
cmd = ("tMt3.txt=\"Bureau     :\"") ;  // Bureau label : 12 car
send_to_nextion(cmd) ; 
cmd = ("tMt4.txt=\"Radiateur  :\"") ;  // Chaudiere label : 12 car
send_to_nextion(cmd) ; 
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void placeMain4Sensor (byte numb ,int OffsetSens)  // TODO : Negative number
{
int transAd =  transfert [OffsetSens] ;
if (transAd % 100 > 95)  // Rounding
      transAd +=5 ;
String cmd = ("tM") ; 
cmd += (numb) ; 
cmd += (".txt=\"") ; 
cmd += transAd / 100 ; 
cmd += (".") ; 
transAd = (5 + transAd % 100) / 10 ;
cmd += transAd ;
cmd += (" C\"") ;   
send_to_nextion(cmd) ;
  dbSerialPrintln(cmd);
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void placeConfig ()
{
;//displayHMS (clkConfig) ;  
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

///////////////   Partie Metier ; donnees ///////////

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++



// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void SimulateMainDatas(void)
{
dbSerialPrintln("Create Main Panel : Random values for demo\n");
/*transfert [OffsetHH] = random (24) ;
transfert [OffsetMM] = random (60) ;
transfert [OffsetSS] = random (60) ;*/
transfert [OffsetSens0] = random (20000) ; //Press
transfert [OffsetSens1] = 1500 + random (1000) ; // Salon
transfert [OffsetSens2] = 1500 + random (1000) ; // Nord
transfert [OffsetSens3] = 1500 + random (1000) ; // Bureau
transfert [OffsetSens4] = 1500 + random (1000) ; // radiateur
transfert [OffsetQuant] = random (365) ;   // Quantieme
transfert [OffsetChannel] = random (6) ;  // Sensors channel
transfert [OffsetAlti] =  random (2000) ; // Presure
/*transfert [OffsetWeekday] =  random (7) ;
transfert [OffsetDay] =  1+random (30) ;
transfert [OffsetMonth] =  1+random (12) ;
transfert [OffsetYear] =  2000 + random (25) ;
transfert [OffsetHH] = random (24) ;
transfert [OffsetMM] = random (60) ;
transfert [OffsetSS] = random (60) ;*/

    dbSerialPrint("    Sens0 =  ") ;
    dbSerialPrintln(transfert [OffsetSens0]);
    dbSerialPrint("    Sens1 =  ") ;
    dbSerialPrintln(transfert [OffsetSens1]);
    dbSerialPrint("    Sens2 =  ") ;
    dbSerialPrintln(transfert [OffsetSens2]);
    dbSerialPrint("    Sens3 =  ") ;
    dbSerialPrintln(transfert [OffsetSens3]);
    dbSerialPrint("    Quant  ") ;
    dbSerialPrintln(transfert [OffsetQuant]);
    dbSerialPrint("    Channel =  ") ;
    dbSerialPrintln(transfert [OffsetChannel]);    
    dbSerialPrint("    Alti =  ") ;
    dbSerialPrintln(transfert [OffsetAlti]);
 /*   dbSerialPrint("    Weekday =  ") ;
    dbSerialPrintln(transfert [OffsetWeekday]); 
    dbSerialPrint("    Day =  ") ;
    dbSerialPrintln(transfert [OffsetDay]);
    dbSerialPrint("    Month =  ") ;    
    dbSerialPrintln(transfert [OffsetMonth]); 
    dbSerialPrint("    Year =  ") ; 
    dbSerialPrintln(transfert [OffsetYear]);  
    dbSerialPrint("    HH =  ") ;
    dbSerialPrintln(transfert [OffsetHH]);
    dbSerialPrint("    MM =  ") ;    
    dbSerialPrintln(transfert [OffsetMM]); 
    dbSerialPrint("    SS =  ") ; 
    dbSerialPrintln(transfert [OffsetSS]);  
    dbSerialPrintln(""); */
}    

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

/*void getHMS ()  // For Main and Graph
{
transfert [OffsetHH] = random (24) ;
transfert [OffsetMM] = random (60) ;
transfert [OffsetSS] = random (60) ;
}*/

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void createDemoCurve (byte sensorNumber)  // Simulation metier
{
//topTime = (60 * transfert [OffsetHH]) + transfert [OffsetMM] ; //Number of minutes after 00:00:00 = 0..(1440-1)
topTime = 1439 ;

nbStepsY = 3+random (7) ;
stepOff = 1+ random (3); // 0, 1, 2
int listStep []= {10,25,50} ;
stepOff = listStep [stepOff] ; // 10,25,50
offMinD =  stepOff * random (100) ; // For label printing on Y
offMinD = offMinD - (offMinD%stepOff) ;

Serial.print ("offMinD = ") ;
Serial.print (offMinD) ;
Serial.print (" \tstepOff = ") ;
Serial.print (stepOff) ;
Serial.print (" \tnb Lines Y = ") ;
Serial.print (1+nbStepsY) ;

for (int i = 359 ; i >= 0 ; i--)   // Brute values     
    {
    vari =  random (90);
    offs = offs + random (vari) - random (vari) ; 
        while (offs > Ys)
            offs = offs - random (vari) ;  
      
        while (offs <0)
            offs = offs + random (vari)  ;       
          
    BufEep360[i] =  Ys-offs ; // Alea  
    }
dbSerialPrintln ("\tBufEep360 OK\n") ;
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  
/*
bool NexPage::show(void)
{
    uint8_t buffer[4] = {0};

    const char *name = getObjName();
    if (!name)
    {
        return false;
    }
    
    String cmd = String("page ");
    cmd += name;
    sendCommand(cmd.c_str());
    return recvRetCommandFinished();
}
 */
