//***********************************//
//        SD card read/write         //
//           Module for              //
//      for battery discharge        //
//***********************************//
//        Christian Couderc          //
//         www.voilec.com            //
//***********************************//
//   220207

/*   SD card read/write Module for battery discharge */

int CS = 8 ; 

#include <SPI.h>
#include <SD.h>
#define countName "Archive.txt"
#define counter100 100
File root, myFile;
char filename [14]; // rec_321.txt -> 11+1 car
String buffer;
int counter  ;
// Only one file can be open at a time,
// so you have to close it before opening another.
// *************************************************

void setup() 
{
Serial.begin(115200);
while (!Serial)  ;

counter = checkSDcard() ;
sprintf(filename, "rec_%3d.txt", counter); // Short names format 8.3
Serial.print (F("Datas saved in : ")) ;
Serial.println (filename) ;
 
myFile = SD.open(filename, FILE_WRITE);
if (myFile) 
    {
// Ready to record datas, start of discharge

// demo : in real life loop Voltage*1000 (record must be an interger)
for (int ang =0 ; ang<361 ; ang+=5)
    {
    float record = sin (PI* ang/180);
    myFile.println(int(record*100));
    }
}
else
    {
    Serial.print ("error opening "); 
    Serial.println(filename);    
    while (1); // Reset to kill the program
    }    
myFile.close(); // End of discharge
}

void loop() {}

// *************************************************

void printDirectory(File dir, int numTabs) 
{
while (true) 
    {
    File entry =  dir.openNextFile();
    if (! entry)    
      break; // no more files
    for (uint8_t i = 0; i < numTabs; i++) 
        Serial.print('\t');
    Serial.print(entry.name());
    if (entry.isDirectory()) 
      {
      Serial.println("/");
      printDirectory(entry, numTabs + 1);
      } 
   else 
      {
      Serial.print("\t\t");
      Serial.println(entry.size(), DEC);       // files have sizes, directories do not
      }
    entry.close();
  }
}
// *************************************************
int getCounter () // get and increment
{
int counter ;
myFile = SD.open(countName, FILE_READ);
if (myFile)
  {
  while (myFile.available())
      buffer = myFile.readStringUntil('\n');

  counter = createNewCount (buffer.toInt()); 
  }
else
  counter = createNewCount (0);

return counter;
}
// *************************************************  
int createNewCount (int val)
{
myFile.close();
SD.remove (countName); // Kill the file
myFile = SD.open(countName, FILE_WRITE); // Re-create and fill the file
     if ((val<counter100 )|| (val>998))
          val=counter100 ;   
myFile.println(val+1);  // initial value 
myFile.close();
return val;
}
// *************************************************  
int checkSDcard()
{
Serial.print(F("\n\n\nSD card "));
if (!SD.begin(CS)) 
  {
  Serial.println(F("initialization failed!"));
  return (0);
  }
Serial.println(F("is valid"));
root = SD.open("/");
printDirectory(root, 0);
Serial.println(F(">>>"));


return (getCounter ()) ;
}
// *************************************************
