//***********************************//
//             ESP32  card           //
//                WS2812             //
//***********************************//
//        Christian Couderc          //
//         www.voilec.com            //
//***********************************//
//   211025
// 8 mS to refresh 256 spots
// All ledsON : Brightness    low 5 : // 316 mA at 5V  // 69 mA at 2.7 V (leds low 67 mA)
// All ledsON : Brightness full 255 : //  5A at 5V     // 75 mA at 2.7 V // 223 ma at 4 V

#include <Adafruit_NeoPixel.h>
char buffer[80];
// ******************************

#define PIN        17 // Which pin on the Arduino is connected to the NeoPixels? 
#define NUMPIXELS 256 // How many NeoPixels are attached to the Arduino?
uint8_t cnt ;

Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

// ******************************

void setup() 
{
Serial.begin(115200);  
delay (100);
pixels.begin(); // INITIALIZE NeoPixel strip object (REQUIRED)
pixels.setBrightness (5) ;
}

// ******************************

void loop() 
{
pixels.clear(); // Set all pixel colors to 'off'
for (int largCar=0 ; largCar<NUMPIXELS; largCar++)
  {
  if (cnt%2==0)
      pixels.setPixelColor(largCar, 255, 255,255); // zig zag
  else
      pixels.setPixelColor(reverse(largCar), 255, 255,255); // down
   sprintf(buffer, "largCar: %d   reverse: %d", largCar, reverse(largCar)); 
   Serial.println (buffer);  
   pixels.show();   // Send the updated pixel colors to the hardware.
  delay (70); // To watch changing direction
  }
cnt++;
delay (2000) ;
}

// ******************************
int reverse (int pos)
{
if ((pos/8)%2==0)
     return pos ;
else
     return ((pos+7)-2*(pos%8)) ;   
} 
// ******************************
