//***********************************//
//             ESP32  card           //
//                WS2812             //
//***********************************//
//        Christian Couderc          //
//         www.voilec.com            //
//***********************************//
//   211025
// 8 mS to refresh 256 spots
// All ledsON : Brightness    low 5 : // 316 mA at 5V  // 69 mA at 2.7 V (leds low 67 mA)
// All ledsON : Brightness full 255 : //  5A at 5V     // 75 mA at 2.7 V // 223 ma at 4 V

// 8 mS to refresh 256 spots

#include <Adafruit_NeoPixel.h>

// ******************************

uint32_t panel [] 
{
0, 0, 0, 0, 0, 0, 0, 0,  // 00  00
0, 0, 0, 0, 0, 0, 0, 0,  // 01  
0, 0, 0, 0, 0, 0, 0, 0,  // 02
0, 0, 0, 0, 0, 0, 0, 0,  // 03 
0, 0, 0, 0, 0, 0, 0, 0,  // 04
0, 0, 0, 0, 0, 0, 0, 0,  // 05  
0, 0, 0, 0, 0, 0, 0, 0,  // 06
0, 0, 0, 0, 0, 0, 0, 0,  // 07
0, 0, 0, 0, 0, 0, 0, 0,  // 08
0, 0, 0, 0, 0, 0, 0, 0,  // 09  
0, 0, 0, 0, 0, 0, 0, 0,  // 10  80
0, 0, 0, 0, 0, 0, 0, 0,  // 11  
0, 0, 0, 0, 0, 0, 0, 0,  // 12
0, 0, 0, 0, 0, 0, 0, 0,  // 13 
0, 0, 0, 0, 0, 0, 0, 0,  // 14
0, 0, 0, 0, 0, 0, 0, 0,  // 15  120
0, 0, 0, 0x669900,0x669900, 0, 0, 0, // 16
0, 0, 255, 255,255, 255, 0, 0, // 17
0, 255, 255, 255,255, 255, 255, 0, // 18
255, 255, 255, 255,255, 255, 255,255, // 19
0, 0, 0, 0xcc6600,0xcc6600, 0, 0, 0 , // 20
0,0,0,0xff0000 ,0xff0000,  0, 0, 0,  // 21
0, 0, 0, 255,255, 0, 0, 0 , // 22
0, 0, 0, 255,255, 0, 0, 0 , // 23
0, 0, 0, 0xe600e6, 0xe600e6, 0, 0 , 0, // 24
0, 0, 0, 255,255, 0, 0, 0 , // 25
0, 0, 0, 0x66ff33,0x66ff33, 0, 0, 0 , // 26
0, 0, 0, 255,255, 0, 0, 0 , // 27
0, 0, 0, 0x66ccff,0x66ccff, 0, 0, 0 , // 28
0, 0, 0, 255,255, 0, 0, 0 , // 29
0, 0, 0, 0x00cc00,0x00cc00, 0, 0, 0 , // 30
0, 0, 0, 0xffff1a, 0xffff1a, 0, 0, 0  // 31
};


// Which pin on the Arduino is connected to the NeoPixels?
#define PIN        17 // On Trinket or Gemma, suggest changing this to 1
uint8_t r,g,b,delta ;
uint32_t val ;
// How many NeoPixels are attached to the Arduino?
#define NUMPIXELS 256 // Popular NeoPixel ring size

int deltaStep = 8 ;
Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

#define DELAYVAL 1 // Time (in milliseconds) to pause between pixels
char buffer [50];
long topOld ;
// ******************************

void setup() 
{
Serial.begin(115200);  
pixels.begin(); // INITIALIZE NeoPixel strip object (REQUIRED)
pixels.setBrightness (5) ;
pixels.clear(); // Set all pixel colors to 'off'
}

// ******************************

void loop() 
{
for(int cnt=0; cnt<16; cnt++) 
  {
  for(int i=0; i<NUMPIXELS; i++)  // For each pixel...
    {
    if (deltaStep>0)
      val = panel [(i+delta)%NUMPIXELS] ; 
    else
      val = panel [((2*NUMPIXELS)-129-i-delta)%NUMPIXELS] ; 
    
      pixels.setPixelColor(i, val);
    }
  pixels.show();   // Send the updated pixel colors to the hardware.
  delay(50); // Pause before next pass through loop
  delta+=deltaStep;

  long topNow= millis();
  Serial.println (topNow-topOld);
  topOld =  topNow ;  
  }
  deltaStep = -1*deltaStep ;
//delay (2000);
}

// ******************************
